
jwplayer.key = 'UZQpqZ50KuNfFomTh3Vu6NJ7nJy9i/XLZJQl3X5lWyE=';

var api = 'https://ws1.upeek.tv/api/v2';
var stream;
var replay = false;
var feed;
var intervalUpdateId;
var oldAppViewers;
var oldWebViewers = 0;
var stopped = false;
var log = {};
var pingId;
var firstPlay = false;
var replayId;
var tryReplay = 0;
var session;

$(document).ready(function () {

    var dev = getParamValue('dev');
    if (dev !== '')
        api = dev;

    var isOpera = !!window.opera || navigator.userAgent.indexOf(' OPR/') >= 0;
    var isFirefox = typeof InstallTrigger !== 'undefined';
    var isSafari = Object.prototype.toString.call(window.HTMLElement).indexOf('Constructor') > 0;
    var isChrome = !!window.chrome && !isOpera;
    var isIE = /*@cc_on!@*/false || !!document.documentMode;

    var fullsid = getParamValue('streamid');
    if (fullsid === '') {
        return;		
    }

    var sid = fullsid;
    var sidArr = sid.split('_');
    if (sidArr.length > 1) {
        sid = sidArr[0];
    }

    stream = new Stream(sid);

    if (isSafari) {
        stream.streamFileH = 'http://wl.upeek.tv:8081/rslive/' + sid + '/playlist.m3u8';
        stream.streamFileR = 'http://wl.upeek.tv:8081/rslive/' + sid + '/playlist.m3u8';
        stream.replayFileH = 'http://la1.upeek.tv:1935/hist_upeek/mp4:' + fullsid + '.mp4/playlist.m3u8';
        stream.replayFileR = 'http://la1.upeek.tv:1935/hist_upeek/mp4:' + fullsid + '.mp4/playlist.m3u8';
    } else {
        stream.streamFileH = 'http://wl.upeek.tv:8081/rslive/' + sid + '/playlist.m3u8';
        stream.streamFileR = 'rtmp://wl.upeek.tv:1935/rslive/' + sid;
        stream.replayFileH = 'http://la1.upeek.tv:1935/hist_upeek/mp4:' + fullsid + '.mp4/playlist.m3u8';
        stream.replayFileR = 'rtmp://la1.upeek.tv:1935/hist_upeek/flv:' + fullsid;
    }

    jwplayer('jw-player').setup({
        playlist: [{
            sources: [{ file: stream.streamFileR }, { file: stream.streamFileH }]
        }],
        title: "Watch Live",
        primary: 'flash',
        width: '100%',
        height: '100%',
        stretching: 'fill',
        androidhls: true,
        wmode: 'transparent',
        controls: true,
        rtmp: { bufferlength: 7.5 },
        autostart: true,
        skin: {name: "vapor", active: "#00c5c3", inactive: "white"}
    });

    $.when(loadStreamInfo(sid)).then(function (resp, stt, jqXHR) {

        jwplayer().onReady(function (e) {
            $(".btn-play").attr("disabled", "disabled");
			
            jwplayer().load({
                image: stream.streamCover, sources: [{ file: stream.streamFileH }, { file: stream.streamFileR }],
            }).onPlaylist(function () {
				
                if (replay) {
                    $('.btn-play').html('watch replay');
                    $(".btn-play").removeAttr("disabled");
                }
            }).onPlay(function () {
                if (replay) {
                    $('.btn-play').html('watch replay');
                } else {
                    $('.btn-play').html('start watching');
                }
                $(".btn-play").removeAttr("disabled");
                togglePlay(true);
				
            }).onPause(function () {
                togglePlay(false);
            }).onIdle(function () {
                togglePlay(false);
            }).onComplete(function () {
                replay = false;
                streamOver();                
            }).onError(function () {

            });
        });

        intervalUpdateId = setInterval(updateInfo, 5000);

        pingId = setInterval(pingByAnonymous, 30000);
    });

    $('.btn-share').click(function () {
        $(this).next().toggleClass('active');
    });

    $('.btn-play').click(function () {
        jwplayer().play();
    });

    $('.share-facebook').click(function (e) {

        e.preventDefault();

        FB.ui(feed, function (resp) { });
    });

    $('.share').click(function (e) {

        e.preventDefault();

        var url = $(this).prop('href');

        if (url.indexOf('#') === (url.length - 1)) {
            return false;
        }

        var width = 500, height = 350;
        var top = screen.height / 2 - height / 2;
        var left = screen.width / 2 - width / 2;

        window.open(url, 'uPeek Share', 'top=' + top + ', left=' + left + ', width=' + width + ', height=' + height + ', toolbar=1, resizable=0');
    });

    $('.overlay-over').on('click', 'a', function (e) {
        e.preventDefault();
    });

    $('.player').on('touchstart', function () {
        $('.info').slideToggle(250);
    });

    $('.overlay-over').on('click', '.close', function () {

        $('.overlay-button').removeClass('hidden');
        $('.overlay-over').remove();
    });

});

function getParamValue(paramName) {
    if (paramName === undefined || paramName === '')
        return '';

    var query = window.location.search.trim().replace('?', '');
    if (query === '')
        return '';

    var arr = query.split('&');

    if (arr === undefined || arr === null || arr.length === 0)
        return '';

    for (var i = 0; i < arr.length; i++) {
        var param = arr[i].split('=');

        if (param[0].toLowerCase() === paramName.toLowerCase())
            return param[1];
    }

    return '';
}

function Stream(streamId) {
    this.streamId = streamId;
    this.publishId = -1;
    this.user = '';
    this.title = '';
    this.category = '';
    this.totalShare = 0;
    this.totalLike = 0;
    this.totalView = 1;
    this.currentView = 1;
    this.shareLink = '';
    this.allowReplay = 0;
    this.isPortraitMode = 1;
    this.coverImage = '';
    this.streamFileH = '';
    this.streamFileR = '';
    this.replayFileH = '';
    this.replayFileR = '';
}

function trickyUrl() {
    return 't=' + $.now();
}

function loadStreamInfo(streamId) {
	
    var url = api + '/publishing/getbyname?name=' + streamId + '&' + trickyUrl();
    var req = $.ajax({ url: url, timeout: 15000 });

    req.fail(function (jqXHR, stt, err) {
        $('.btn-play').html('Error occured');
    });

    req.done(function (resp, stt, jqXHR) {
        var data = resp.Data;

        if (data === undefined || data === null) {

            $('.btn-play').html('try again');

            return;
        }

        data = formatData(data);

        var user = data.Username;
        var profileImage = data.ProfileImage;

        var title = data.Title;
        var loca = data.LocationName;
        var cate = data.Category;

        var share = data.TotalShare;
        var like = data.TotalLike;
        var currView = data.CurrentPlay;
        var totalView = data.TotalPlay;
        var shareLink = data.Link;
        var allowReplay = data.AllowReplay;
        var isPortrait = data.IsVideoPortrait;

        stream.publishId = data.PublishID;
        stream.streamCover = data.StreamFullImageUrl;

        stream.totalLike = like;
        stream.totalShare = share;
        stream.totalView = totalView;
        stream.allowReplay = allowReplay;

        if (currView === undefined || currView === 0)
            currView = 1;
        stream.currentView = currView;

        stream.isPortraitMode = isPortrait;
        
        if (!isPortrait) {
            // landscape
            $('.wrapper').addClass('landscape');
        }

        updateUser(user, profileImage);
        updateDetail(title, loca, cate);
        updateCount(stream.totalShare, stream.totalLike, stream.currentView);

        feed = {
            method: 'feed',
            display: 'popup',
            link: data.Link,
            caption: cate,
            picture: stream.streamCover,
            description: title,
            name: user
        };

        var fbShare = 'http://www.facebook.com/sharer.php?u=' + data.Link;
        var twShare = 'http://twitter.com/share?url=' + encodeURI(shareLink) + '&text=' + title;
        var gpShare = 'https://plus.google.com/share?url=' + shareLink;
        var emShare = 'mailto:?subject=Watch%live%on%uPeek?body=' + shareLink;

        $('.share-facebook').prop('href', fbShare);
        $('.share-twitter').prop('href', twShare);
        $('.share-gplus').prop('href', gpShare);
        $('.share-email').prop('href', emShare);

    });

    return req;
}

function formatData(data) {

    if (typeof data === 'object') {
        $.each(data, function (key, value) {
            if (value === undefined || value === null || value === '')
                data[key] = '';
        });

        return data;
    }


    if (data === undefined || data === null || data === '')
        return ' ';

    return data;
}

function updateUser(username, image) {
    var $user = $('.info-user');

    $user.children('div').first().children('img').prop('src', image);
    $user.children('div').last().text(username);
}


function updateDetail(title, loca, cate) {
    var $detail = $('.info-detail');

    $detail.children('.detail-title').text(title);
    $detail.children('.detail-location').text(loca);
    $detail.children('.detail-category').text(cate);
}

function updateCount(share, like, view) {
    var $count = $('.info-count');

    if (isNaN(share)) share = 0;
    if (isNaN(like)) like = 0;
    if (isNaN(view) || view === 0) view = 1;

    $count.children('.count-share').find('span').text(share);
    $count.children('.count-like').find('span').text(like);
    $count.children('.count-view').find('span').text(view);
}

function streamOver() {

    if (stopped) {
        return;
    }
	
    if (replay && stream.allowReplay > 0) {

        $('.btn-play').html('watch replay');

        jwplayer().load({
            image: stream.streamCover,
            sources: [{ file: stream.replayFileR }, { file: stream.replayFileH }]
        });

        updateCount(stream.totalShare, stream.totalLike, stream.totalView);

        if (intervalUpdateId !== undefined && !isNaN(intervalUpdateId)) {
            clearInterval(intervalUpdateId);
        }

        if (pingId !== undefined && !isNaN(pingId)) {
            clearInterval(pingId);
        }

        return;
    }

    jwplayer().play(false);
    stopped = true;

    if (session !== undefined && typeof session === 'object') {
        session.clear();
    }

    $('.main').removeClass('playing');
    $('.overlay').fadeIn();
    $('.overlay-button').addClass('hidden');
    $('.overlay-over').removeClass('hidden');

    updateCount(stream.totalShare, stream.totalLike, stream.totalView);

    if (intervalUpdateId !== undefined && !isNaN(intervalUpdateId)) {
        clearInterval(intervalUpdateId);
    }
    if (pingId !== undefined && !isNaN(pingId)) {
        clearInterval(pingId);
    }

}

function togglePlay(isPlay) {
    if (isPlay) {
        $('.overlay').fadeOut();
        $('.main').addClass('playing');
    } else {
        $('.overlay').fadeIn();
        $('.main').removeClass('playing');
    }
}

function updateInfo() {

    if (stopped || replay) {

        if (intervalUpdateId !== undefined && !isNaN(intervalUpdateId))
            clearInterval(intervalUpdateId);

        return;
    }

    var url = api + '/publishing/checkstreamlive3?streamid=' + stream.publishId + '&' + trickyUrl();
    var req = $.ajax({ url: url, timeout: 5000 });

    req.fail(function (jqXHR, stt, err) {

    });

    req.done(function (resp, stt, jqXHR) {

        var data = resp.Data;

        if (data === undefined || data === null)
            return;

        if (!isNaN(data.TotalPlay) && data.TotalPlay > 0)
            stream.totalView = data.TotalPlay;

        if (!isNaN(data.TotalLike) && data.TotalLike > 0)
            stream.totalLike = data.TotalLike;

        if (!isNaN(data.TotalShare) && data.TotalShare > 0)
            stream.totalShare = data.TotalShare;

        if (!data.StreamALive) {
            replay = true;
            streamOver();
            return;
        } else {
            $('.btn-play').html('start watching');
            $(".btn-play").removeAttr("disabled");
        }

        if (!isNaN(data.CurrentPlay))
            stream.currentView = data.CurrentPlay === 0 ? 1 : data.CurrentPlay;

        updateCount(stream.totalShare, stream.totalLike, stream.currentView);

    });

}

function pingByAnonymous() {

    if (replay) {

        if (!isNaN(pingId) && pingId > 0) {
            clearInterval(pingId);
        }

        return;
    }

    session = window.sessionStorage;
    if (session === undefined || typeof session !== 'object')
        return;

    if (session.anonymous === undefined) {

        if (stream.publishId === -1) {
            return;
        }

        var anonymousUrl = api + '/webview/add';
        var anonymousData = { ID: 0, StreamID: stream.publishId };
        var anonymousReq = $.ajax({ url: anonymousUrl, data: anonymousData, method: 'post' });

        anonymousReq.fail(function (jqXHR, err, sttText) {

        }).done(function (resp, stt, jqXHR) {

            var anonymousId = +resp.Data;

            if (isNaN(anonymousId) || anonymousId < 0) {
                return;
            }

            var anonymous = { anonymousId: anonymousId };
            session.anonymous = JSON.stringify(anonymous);

            updateInfo();
        });

    } else {

        var anonymous = JSON.parse(session.anonymous);

        var pingurl = api + '/webview/lastalive?id=' + anonymous.anonymousId + '&' + trickyUrl();
        var pingreq = $.ajax({ url: pingurl, timeout: 30000 });

        pingreq.done(function (resp, stt, jqXHR) {

        }).fail(function (jqXHR, stt, err) {

        });
    }
}